#include "wstp.h"
 
void mandelbrot(double xmin, double xmax, double ymin, double ymax, int xres, int yres)
{
   double x, y, dist, cx, cy, temp;
   int column, row, counts;
     
   WSPutFunction(stdlink, "List", yres);
   for(row = 0; row < yres; row++)
  	{
   	  cy = ymin + (ymax - ymin)*row/(yres - 1.0);
   	  WSPutFunction(stdlink, "List", xres);
   	  for(column = 0; column < xres ; column++)
    		{
     		  x = 0;
     		  y = 0;
     		  cx = xmin + (xmax - xmin)*column/(xres - 1.0);	  
     		  dist = 0;
     		  for(counts = 0; counts < 100 && dist < 4; counts++)
      			{
       			  temp = x*x - y*y + cx;
       			  y = 2*x*y + cy;
       			  x = temp;
       			  dist = x*x + y*y;
       		  }
      		  WSPutInteger(stdlink, counts);
     	  }
     }
 }

int main(int argc, char *argv[])
{ 
 	return WSMain(argc, argv);
}